# std::ratio_not_equal

From cppreference.com
< cpp‎ | numeric‎ | ratio

Defined in header `<ratio>` |  |
template< class R1, class R2 > struct ratio_not_equal : std::integral_constant; |  | (since C++11)

If the ratios R1 and R2 are not equal, provides the member constant `value` equal true. Otherwise, `value` is false.

### Helper variable template

template< class R1, class R2 > inline constexpr bool ratio_not_equal_v = ratio_not_equal<R1, R2>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if R1::num != R2::num || R1::den != R2::den , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Possible implementation

    template< class R1, class R2 >
    struct ratio_not_equal : std::integral_constant <
                                  bool,
                                  !std::ratio_equal<R1, R2>
                             > {};

### Example

Run this code

    #include <iostream>
    #include <ratio>

    int main()
    {
        if(std::ratio_not_equal<std::ratio<2,3>, std::ratio<1,3>>::value) {
            std::cout << "2/3 != 1/3\n";
        } else {
            std::cout << "2/3 == 1/3\n";
        }
    }

Output:

    2/3 != 1/3

### See also

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/numeric/ratio/ratio_not_equal&oldid=106108"